#include "rc522.h"

sbit RST_RC522 = P0^3;
sbit CS_RC522 = P0^4;

uchar RC552_rx(uchar addr)
{
	CS_RC522=0;
	addr = ((addr<<1)&0x7E)|0x80;
	spi_tx(addr);
	spi_tx(0xff);
	CS_RC522=1;
	return SPDAT;
}

void RC552_tx(uchar addr,uchar dat)
{
	SPCTL=0xd1;
	CS_RC522=0;
	addr = ((addr<<1)&0x7E);
	spi_tx(addr);
	spi_tx(dat);
	CS_RC522=1;
	SPCTL   = (SSIG << 7)|(SPEN << 6)|(DORD << 5)|(MSTR << 4)|(CPOL << 3)|(CPHA << 2)|SPR;
}

void RC522_CBIT(uchar addr,uchar dat)
{
	uchar ram;
	ram = RC552_rx(addr);
	RC552_tx(addr,ram & ~dat);
}

void RC522_SBIT(uchar addr,uchar dat)
{
	uchar ram;
	ram = RC552_rx(addr);
	RC552_tx(addr,ram | dat);
}

void RC522_init()
{
	RST_RC522 = 1;
	delay(1);
	RST_RC522 = 0;
	delay(1);
	RST_RC522 = 1;
	delay(10);
	RC552_tx(CommandReg,0x0f);
	
	RC552_tx(ModeReg,0x3D);            //MifareͨѶCRCʼֵ0x6363CRCPreset=01
  RC552_tx(TReloadRegL,30);          //ʱװֵΪ8λĴʼֵΪ0x00      
  RC552_tx(TReloadRegH,0);
  RC552_tx(TModeReg,0x8D);           //ڲʱ1000 1101,λΪTPrescalerRegĸλ
  RC552_tx(TPrescalerReg,0x3E);      //ΪTPregScaler8λFtimer = 6.78MHZ/TPreScaler
  RC552_tx(TxAutoReg,0x40);
	antenna_SET(0);//
	antenna_SET(1);//
	//ISO14443_A
	RC522_CBIT(Status2Reg,0x08);
	RC552_tx(ModeReg,0x3D);//3
	RC552_tx(RxSelReg,0x86);//
	RC552_tx(RFCfgReg,0x7F);   //4F
	RC552_tx(TReloadRegL,30);//tmoLength);// TReloadVal = 'h6a =tmoLength(dec) 
	RC552_tx(TReloadRegH,0);
	RC552_tx(TModeReg,0x8D);
	RC552_tx(TPrescalerReg,0x3E);
	delay(1);
	antenna_SET(1);
}

void antenna_SET(uchar cmd)//0ߣ!0
{
	uchar i;
	if(cmd)
	{
		i=RC552_rx(TxControlReg);
		if (!(i & 0x03))
    {
			RC522_SBIT(TxControlReg, 0x03);
    }
	}
	else
	{
		RC522_CBIT(TxControlReg, 0x03);
	}
}

void found_card ()
{
	RC522_CBIT(Status2Reg,0x80);
	RC552_tx(BitFramingReg,0x07);
	RC522_SBIT(TxControlReg,0x03);
}


/////////////////////////////////////////////////////////////////////
//    ܣѰ
//˵: req_code[IN]:Ѱʽ
//                0x52 = ѰӦз14443A׼Ŀ
//                0x26 = Ѱδ״̬Ŀ
//          pTagType[OUT]Ƭʹ
//                0x4400 = Mifare_UltraLight
//                0x0400 = Mifare_One(S50)
//                0x0200 = Mifare_One(S70)
//                0x0800 = Mifare_Pro(X)
//                0x4403 = Mifare_DESFire
//    : ɹMI_OK
/////////////////////////////////////////////////////////////////////
char PcdRequest(unsigned char req_code,unsigned char *pTagType){
   char status;  
   unsigned int  unLen;
   unsigned char ucComMF522Buf[MAXRLEN]; 
   RC522_CBIT(Status2Reg,0x08);
   RC552_tx(BitFramingReg,0x07);
   RC522_SBIT(TxControlReg,0x03);
   ucComMF522Buf[0] = req_code;
   status = PcdComMF522(PCD_TRANSCEIVE,ucComMF522Buf,1,ucComMF522Buf,&unLen);
   if ((status == MI_OK) && (unLen == 0x10))
   {    
       *pTagType     = ucComMF522Buf[0];
       *(pTagType+1) = ucComMF522Buf[1];
   }
   else
   {   status = MI_ERR;   }   
   return status;
}

/////////////////////////////////////////////////////////////////////
//    ܣͨRC522ISO14443ͨѶ
//˵Command[IN]:RC522
//          pInData[IN]:ͨRC522͵Ƭ
//          InLenByte[IN]:ݵֽڳ
//          pOutData[OUT]:յĿƬ
//          *pOutLenBit[OUT]:ݵλ
/////////////////////////////////////////////////////////////////////
char PcdComMF522(unsigned char Command, 
                 unsigned char *pInData, 
                 unsigned char InLenByte,
                 unsigned char *pOutData, 
                 unsigned int  *pOutLenBit)
{
    char status = MI_ERR;
    unsigned char irqEn   = 0x00;
    unsigned char waitFor = 0x00;
    unsigned char lastBits;
    unsigned char n;
    unsigned int i;
    switch (Command)
    {
       case PCD_AUTHENT:
          irqEn   = 0x12;
          waitFor = 0x10;
          break;
       case PCD_TRANSCEIVE:
          irqEn   = 0x77;
          waitFor = 0x30;
          break;
       default:
         break;
    }
   
    RC552_tx(ComIEnReg,irqEn|0x80);
    RC522_CBIT(ComIrqReg,0x80);
    RC552_tx(CommandReg,PCD_IDLE);
    RC522_SBIT(FIFOLevelReg,0x80);
    
    for (i=0; i<InLenByte; i++)
    {   RC552_tx(FIFODataReg, pInData[i]);    }
    RC552_tx(CommandReg, Command);
   
    
    if (Command == PCD_TRANSCEIVE)
    {    RC522_SBIT(BitFramingReg,0x80);  }
    
//    i = 600;//ʱƵʵM1ȴʱ25ms
 i = 2000;
    do 
    {
         n = RC552_rx(ComIrqReg);
         i--;
    }
    while ((i!=0) && !(n&0x01) && !(n&waitFor));
    RC522_CBIT(BitFramingReg,0x80);
	      
    if (i!=0)
    {    
         if(!(RC552_rx(ErrorReg)&0x1B))
         {
             status = MI_OK;
             if (n & irqEn & 0x01)
             {   status = MI_NOTAGERR;   }
             if (Command == PCD_TRANSCEIVE)
             {
               	n = RC552_rx(FIFOLevelReg);
              	lastBits = RC552_rx(ControlReg) & 0x07;
                if (lastBits)
                {   *pOutLenBit = (n-1)*8 + lastBits;   }
                else
                {   *pOutLenBit = n*8;   }
                if (n == 0)
                {   n = 1;    }
                if (n > MAXRLEN)
                {   n = MAXRLEN;   }
                for (i=0; i<n; i++)
                {   pOutData[i] = RC552_rx(FIFODataReg);    }
            }
         }
         else
         {   status = MI_ERR;   }
        
   }
   

   RC522_SBIT(ControlReg,0x80);           // stop timer now
   RC552_tx(CommandReg,PCD_IDLE); 
   return status;
}

/////////////////////////////////////////////////////////////////////
//    ܣײ
//˵: pSnr[OUT]:Ƭкţ4ֽ
//    : ɹMI_OK
/////////////////////////////////////////////////////////////////////  
char PcdAnticoll(unsigned char *pSnr)
{
    char status;
    unsigned char i,snr_check=0;
    unsigned int  unLen;
    unsigned char ucComMF522Buf[MAXRLEN]; 
    

    RC522_CBIT(Status2Reg,0x08);
    RC552_tx(BitFramingReg,0x00);
    RC522_CBIT(CollReg,0x80);
 
    ucComMF522Buf[0] = PICC_ANTICOLL1;
    ucComMF522Buf[1] = 0x20;

    status = PcdComMF522(PCD_TRANSCEIVE,ucComMF522Buf,2,ucComMF522Buf,&unLen);

    if (status == MI_OK)
    {
    	 for (i=0; i<4; i++)
         {   
             *(pSnr+i)  = ucComMF522Buf[i];
             snr_check ^= ucComMF522Buf[i];
         }
         if (snr_check != ucComMF522Buf[i])
         {   status = MI_ERR;    }
    }
    
    RC522_SBIT(CollReg,0x80);
    return status;
}