#include "tft_lcd.h"
#include "spi.h"

#define TFT_DATA_H P7
#define TFT_DATA_L P0

void lcd_cmd(uchar dat)
{
	SPCTL=0x9f;//TFTܽSPIܽźãLCDǰȽSPI
	DC_TFT_LCD=0;
	CS_TFT_LCD=0;
	
	TFT_DATA_H=0;
	TFT_DATA_L=dat;
	
	WRX_TFT_LCD=0;
	WRX_TFT_LCD=1;
	CS_TFT_LCD=1;
}

void lcd_dat(uchar dat)
{
	SPCTL=0x9f;
	DC_TFT_LCD=1;
	CS_TFT_LCD=0;
	
	TFT_DATA_H=0;
	TFT_DATA_L=dat;
	
	WRX_TFT_LCD=0;
	WRX_TFT_LCD=1;
	CS_TFT_LCD=1;
}

void lcd_2dat(uint dat)
{
	SPCTL=0x9f;
	DC_TFT_LCD=1;
	CS_TFT_LCD=0;
	
	TFT_DATA_H=dat>>8;
	TFT_DATA_L=dat;
	
	WRX_TFT_LCD=0;
	WRX_TFT_LCD=1;
	CS_TFT_LCD=1;
}

void lcd_init_ST7789()
{
	P6 &= 0xf8;
	P6 |= 0x02;
	delay(20);
	RDX_TFT_LCD=1;
	RES_TFT_LCD=1;
	delay(20);
	RES_TFT_LCD=0;
	delay(20);
	RES_TFT_LCD=1;
	delay(300);
	
	
	lcd_cmd(0xF0);     //ƣC3=õһ֣96=õڶ֣3C=õһ֣69=õڶ
	lcd_dat(0xC3);   

	lcd_cmd(0xF0);     
	lcd_dat(0x96);   

	lcd_cmd(0x36);    // Memory Access Control
	lcd_dat(0x48);  

	lcd_cmd(0x3A);     //RGBӿظʽ     4λD7̶0D6~4101=16λ/أ110=18λ/
	lcd_dat(0x55);   	 //ƽӿظʽ4λD3̶0D2~0101=16λ/أ110=18λ/أ111=24λ/

	lcd_cmd(0xB4);     //ʾתƣ0=зת1=㷴ת2=˫㷴ת3=
	lcd_dat(0x01);   

	lcd_cmd(0xB1);     //֡ʿƣ2ֽݣһֽڣ
	lcd_dat(0xb0);   	 //FRS[D7-D4], DIVA[D1-D0] 81 for 15Hz //0x80
	lcd_dat(0x10);     //RTNA[4:0]

	lcd_cmd(0xB5);     
	lcd_dat(0x00);   //VFP FF for 15Hz //0x1f
	lcd_dat(0x00);   //VBP FF for 15Hz //0x50
	lcd_dat(0x00);   
	lcd_dat(0x20);   //HBP

	lcd_cmd(0xB6);     
	lcd_dat(0x8A);   
	lcd_dat(0x07);   
	lcd_dat(0x3B);   //480 Gates

	lcd_cmd(0xC0);     
	lcd_dat(0x80);   
	lcd_dat(0x64); //VGH=15V VGL=-10V  

	lcd_cmd(0xC1);     
	lcd_dat(0x13);  //VOP=4.5V

	lcd_cmd(0xC2);     
	lcd_dat(0xA7);   

	lcd_cmd(0xC5);     
	lcd_dat(0x09);   

	lcd_cmd(0xE8);     
	lcd_dat(0x40);   
	lcd_dat(0x8a);   
	lcd_dat(0x00);   
	lcd_dat(0x00);   
	lcd_dat(0x29);   
	lcd_dat(0x19);   
	lcd_dat(0xA5);   
	lcd_dat(0x33);   

	lcd_cmd(0xE0);
	lcd_dat(0xF0);
	lcd_dat(0x06);
	lcd_dat(0x0B);
	lcd_dat(0x07);
	lcd_dat(0x06);
	lcd_dat(0x05);
	lcd_dat(0x2E);
	lcd_dat(0x33);
	lcd_dat(0x47);
	lcd_dat(0x3A);
	lcd_dat(0x17);
	lcd_dat(0x16);
	lcd_dat(0x2E);
	lcd_dat(0x31);

	lcd_cmd(0xE1);
	lcd_dat(0xF0);
	lcd_dat(0x09);
	lcd_dat(0x0D);
	lcd_dat(0x09);
	lcd_dat(0x08);
	lcd_dat(0x23);
	lcd_dat(0x2E);
	lcd_dat(0x33);
	lcd_dat(0x46);
	lcd_dat(0x38);
	lcd_dat(0x13);
	lcd_dat(0x13);
	lcd_dat(0x2C);
	lcd_dat(0x32);

	lcd_cmd(0xF0);     
	lcd_dat(0x3C);   

	lcd_cmd(0xF0);     
	lcd_dat(0x69);  

	lcd_cmd(0x35);     	//ͷ˺Чͬ
	lcd_dat(0x00); 

	lcd_cmd(0x11);      //˳˯ģʽҪʱĵȴڲ·0X10˯ģʽ

	delay(2000);                //ms

	lcd_cmd(0x29);      //ʾģʽ0X28رʾģʽ
	delay(500); 
		
	lcd_cmd(0x21);      //رʾģʽɫ0x20ʾ
	
	BLK_TFT_LCD=1;
	
	lcd_cmd(0x36);      //洢ݷʿ
	lcd_dat(0x40);      //D7еַ˳D6еַ˳D5нD4ֱˢ˳0=£D3ɫ˳0=RGB/1=BGRD2ˮƽˢ˳0=ҡ
	
	lcd_cmd(0x2c);
	lcd_full(0xffff);
	lcd_full(0x0000);
}

void lcd_address_set(uint x1,uint y1,uint x2,uint y2)
{
	lcd_cmd(0x2a);//еַ
	
	lcd_dat((uchar)(x1>>8));
	lcd_dat((uchar)(x1%256));
	lcd_dat((uchar)(x2>>8));
	lcd_dat((uchar)(x2%256));
	
	lcd_cmd(0x2b);//еַ
	
	lcd_dat((uchar)(y1>>8));
	lcd_dat((uchar)(y1%256));
	lcd_dat((uchar)(y2>>8));
	lcd_dat((uchar)(y2%256));
	
	lcd_cmd(0x2c);//д
}

void lcd_full(uint color)
{
	uint i,j;
	lcd_address_set(0,0,LCD_W-1,LCD_H-1);//ʾΧ
	for(i=0;i<LCD_H;i++)
	{													   	 	
		for(j=0;j<LCD_W;j++)
		{
			lcd_2dat(color);
		}
	}
}

void lcd_test()
{
	uint i,j;
	static uint color;
	lcd_address_set(0,0,LCD_W-1,LCD_H-1);//ʾΧ
	for(i=0;i<LCD_H;i++)
	{													   	 	
		for(j=0;j<LCD_W;j++)
		{
			lcd_2dat(color);
			color++;
		}
	}
}


uchar xdata *L_RAM;

void GT30L32S4W_RX(uchar H,uchar M,uchar L,uint j)
{
	uint i;
	CS_GT30=0;
	spi_tx(0x03);
	spi_tx(H);
	spi_tx(M);
	spi_tx(L);
	for(i=0;i<j;i++)
	{
		spi_tx(0xff);
		L_RAM[i]=SPDAT;
	}
	CS_GT30=1;
}

void LCD_dot(uint x,uint y,uint color)
{
	lcd_address_set(x,y,x,y);
	lcd_2dat(color);
}

void LCD_big_dot(uint x,uint y,uint color)
{
	LCD_dot(x-1,y-1,color);LCD_dot(x,y-1,color);LCD_dot(x+1,y-1,color);
	LCD_dot(x-1,y,color)  ;LCD_dot(x,y,color)  ;LCD_dot(x+1,y,color);
	LCD_dot(x-1,y+1,color);LCD_dot(x,y+1,color);LCD_dot(x+1,y+1,color);
}

void LCD_block(uint x1,uint y1,uint x2,uint y2,uint color)
{
	ulong i,k;
	lcd_address_set(x1,y1,x2,y2);
	for(i=0;i<(x2-x1+1);i++)
	{
		for(k=0;k<(y2-y1+1);k++)
		{
			lcd_2dat(color);
		}
	}
}

void Display_GB2312_holo(uint x,uint y,uchar zk_num,uint fc)
{
  uchar i,k,n,d,m=0;
	uchar y_p=0;
	switch(zk_num)
	{
		// n:ַռֽ  dּ
		case 12 :  n=24;  d=12; break;   // 12*12
		case 16 :  n=32;  d=16; break;   // 15*16
		case 24 :  n=72;  d=24; break;   // 24*24
		case 32 :  n=128; d=32; break;   // 32*32
	}
	for(i=0;i<n;i++)
	{
		for(k=0;k<8;k++)
		{
			if((L_RAM[i]&(0x80>>k)))
			{
			  LCD_dot(x+m,y+y_p,fc);
			}
			m++;
			if(m%zk_num==0)
			{
				m=0;
				y_p++;
				break;
			}
		}
		
	}
}

void Display_GB2312(uint x,uint y,uchar zk_num,uint fc,uint bc)
{
  uchar i,k,n,d,m=0;
	switch(zk_num)
	{
		// n:ַռֽ  dּ
		case 12 :  n=24;  d=12; break;   // 12*12
		case 16 :  n=32;  d=16; break;   // 15*16
		case 24 :  n=72;  d=24; break;   // 24*24
		case 32 :  n=128; d=32; break;   // 32*32
	}
	lcd_address_set(x,y,x+d-1,y+d-1);
	for(i=0;i<n;i++)
	{
		for(k=0;k<8;k++)
		{
			if((L_RAM[i]&(0x80>>k)))
			{
			  lcd_2dat(fc);
			}
			else
			{
			  lcd_2dat(bc);
			}
			m++;
			if(m%zk_num==0)
			{
				m=0;
				break;
			}
		}
	}
}

void Display_Asc_holo(uint x,uint y,uchar zk_num,uint fc)
{
  uchar i,k,n,x0,y0,m=0;
	uchar y_p=0;
	switch(zk_num)
	{
		// n:ַռֽ  dּ
		case 7:   n=7;  x0=5;  y0=7;  break;	 //	  5x7 ASCII
		case 8:   n=8;  x0=7;  y0=8;  break;	 //   7x8 ASCII
		case 12:  n=12; x0=6;  y0=12; break;	 //  6x12 ASCII
	  case 16:  n=16; x0=8;  y0=16; break;	 //  8x16 ASCII	
	  case 24:  n=48; x0=12; y0=24; break;	 //  12x24 ASCII
	 	case 32:  n=64; x0=16; y0=32; break;	 //  16x32 ASCII
	}
	for(i=0;i<n;i++)
	{
		for(k=0;k<8;k++)
		{
			if((L_RAM[i]&(0x80>>k)))
			{
			  LCD_dot(x+m,y+y_p,fc);
			}
			m++;
			if(m%x0==0)
			{
				m=0;
				y_p++;
				break;
			}
		}
	}
}
void Display_Asc(uint x,uint y,uchar zk_num,uint fc,uint bc)
{
  uchar i,k,n,x0,y0,m=0;
	switch(zk_num)
	{
		// n:ַռֽ  dּ
		case 7:   n=7;  x0=5;  y0=7;  break;	 //	  5x7 ASCII
		case 8:   n=8;  x0=7;  y0=8;  break;	 //   7x8 ASCII
		case 12:  n=12; x0=6;  y0=12; break;	 //  6x12 ASCII
	  case 16:  n=16; x0=8;  y0=16; break;	 //  8x16 ASCII	
	  case 24:  n=48; x0=12; y0=24; break;	 //  12x24 ASCII
	 	case 32:  n=64; x0=16; y0=32; break;	 //  16x32 ASCII
	}
	lcd_address_set(x,y,x+x0-1,y+y0-1);
	for(i=0;i<n;i++)
	{
		for(k=0;k<8;k++)
		{
			if((L_RAM[i]&(0x80>>k)))
			{
			  lcd_2dat(fc);
			}
			else
			{
			  lcd_2dat(bc);
			}
			m++;
			if(m%x0==0)
			{
				m=0;
				break;
			}
		}
	}
}

void LCD_GB2312_String(uint x,uint y,uchar zk_num,uchar *text,uint fc,uint bc)//X꣬Y꣬ѡС֣ɫɫ
{
	uchar i= 0;
	uchar AddrHigh,AddrMid,AddrLow ; //ָߡС͵ַ
	ulong FontAddr=0; //ֵַ
	ulong BaseAdd=0; //ַֿ	
	uchar n,d;// ֿͬļ
	switch(zk_num)
	{
		// n:ַռֽ  dּ
		case 12 :  BaseAdd=0x00;    n=24;  d=12; break;   // 12*12  
		case 16 :  BaseAdd=0x2C9D0; n=32;  d=16; break;   // 15*16  
		case 24 :  BaseAdd=0x68190; n=72;  d=24; break;   // 24*24  
		case 32 :  BaseAdd=0xEDF00; n=128; d=32; break;   // 32*32  
	}
	while((text[i]>0x00))
	{
		if(((text[i]>=0xA1)&&(text[i]<=0xA9))&&(text[i+1]>=0xA1))
		{						
			//壨GB2312 ֿICеĵַ¹ʽ㣺//
			//Address = ((MSB - 0xA1) * 94 + (LSB - 0xA1))*n+ BaseAdd; ȡַ///
			FontAddr = (text[i]- 0xA1)*94; 
			FontAddr += (text[i+1]-0xA1);
			FontAddr = (unsigned long)((FontAddr*n)+BaseAdd);
			
			AddrHigh = (FontAddr&0xff0000)>>16;  //ַĸ8λ,24λ//
			AddrMid = (FontAddr&0xff00)>>8;      //ַ8λ,24λ//
			AddrLow = FontAddr&0xff;	     //ַĵ8λ,24λ//
			GT30L32S4W_RX(AddrHigh,AddrMid,AddrLow,n );//ȡһֵݣ浽"FontBuf[]"
			if(fc==bc)
			{
				Display_GB2312_holo(x,y,zk_num,fc);
			}
			else
			{
				Display_GB2312(x,y,zk_num,fc,bc);//ʾһֵLCD/ 
			}
		}
		else if(((text[i]>=0xB0) &&(text[i]<=0xF7))&&(text[i+1]>=0xA1))
		{
			//壨GB2312 ֿICеĵַ¹ʽ㣺//
			//Address = ((MSB - 0xB0) * 94 + (LSB - 0xA1)+846)*n+ BaseAdd; ȡַ//
			FontAddr = (text[i]- 0xB0)*94; 
			FontAddr += (text[i+1]-0xA1)+846;
			FontAddr = (unsigned long)((FontAddr*n)+BaseAdd);
			
			AddrHigh = (FontAddr&0xff0000)>>16;  //ַĸ8λ,24λ//
			AddrMid = (FontAddr&0xff00)>>8;      //ַ8λ,24λ//
			AddrLow = FontAddr&0xff;	     //ַĵ8λ,24λ//
			GT30L32S4W_RX(AddrHigh,AddrMid,AddrLow,n);//ȡһֵݣ浽"FontBuf[ ]"
			if(fc==bc)
			{
				Display_GB2312_holo(x,y,zk_num,fc);
			}
			else
			{
				Display_GB2312(x,y,zk_num,fc,bc);//ʾһֵLCD/ 
			}
		}
		if((text[i] >= 0x20) &&(text[i] <= 0x7E))
		{
			switch(zk_num)
			{
				//nd:ּ
				case 7:   BaseAdd=0x1DDF80; n=8;  d=6;  break;	 //	  5x7 ASCII
				case 8:   BaseAdd=0x1DE280; n=8;  d=7;  break;	 //   7x8 ASCII
				case 12:  BaseAdd=0x1DBE00; n=12; d=6;  break;	 //  6x12 ASCII
				case 16:  BaseAdd=0x1DD780; n=16; d=8;  break;	 //  8x16 ASCII	
				case 24:  BaseAdd=0x1DFF00; n=48; d=12; break;	 //  12x24 ASCII
				case 32:  BaseAdd=0x1E5A50; n=64; d=16; break;	 //  16x32 ASCII
			}
		  FontAddr = 	text[i]-0x20;
			FontAddr = (unsigned long)((FontAddr*n)+BaseAdd);
			
			AddrHigh = (FontAddr&0xff0000)>>16;  /*ַĸ8λ,24λ*/
			AddrMid = (FontAddr&0xff00)>>8;      /*ַ8λ,24λ*/
			AddrLow = FontAddr&0xff;	     /*ַĵ8λ,24λ*/
			GT30L32S4W_RX(AddrHigh,AddrMid,AddrLow,n);/*ȡһֵݣ浽"FontBuf[]"*/
			if(fc==bc)
			{
				Display_Asc_holo(x,y,zk_num,fc);
			}
			else
			{
				Display_Asc(x,y,zk_num,fc,bc);/*ʾһasciiLCD */
			}
			i+=1;  //¸ַ
		}
		else
		{
			i+=2;  //¸ַ
		}
		x+=d; //һ
		
	}
}






void LCD_num(uint x,uint y,uchar zk_num,uchar num,uint fc,uint bc)
{
	if(num==0){LCD_GB2312_String(x,y,zk_num,"0",fc,bc);}
	else if(num==1){LCD_GB2312_String(x,y,zk_num,"1",fc,bc);}
	else if(num==2){LCD_GB2312_String(x,y,zk_num,"2",fc,bc);}
	else if(num==3){LCD_GB2312_String(x,y,zk_num,"3",fc,bc);}
	else if(num==4){LCD_GB2312_String(x,y,zk_num,"4",fc,bc);}
	else if(num==5){LCD_GB2312_String(x,y,zk_num,"5",fc,bc);}
	else if(num==6){LCD_GB2312_String(x,y,zk_num,"6",fc,bc);}
	else if(num==7){LCD_GB2312_String(x,y,zk_num,"7",fc,bc);}
	else if(num==8){LCD_GB2312_String(x,y,zk_num,"8",fc,bc);}
	else if(num==9){LCD_GB2312_String(x,y,zk_num,"9",fc,bc);}
	
	else if(num==10){LCD_GB2312_String(x,y,zk_num,"A",fc,bc);}
	else if(num==11){LCD_GB2312_String(x,y,zk_num,"B",fc,bc);}
	else if(num==12){LCD_GB2312_String(x,y,zk_num,"C",fc,bc);}
	else if(num==13){LCD_GB2312_String(x,y,zk_num,"D",fc,bc);}
	else if(num==14){LCD_GB2312_String(x,y,zk_num,"E",fc,bc);}
	else if(num==15){LCD_GB2312_String(x,y,zk_num,"F",fc,bc);}
}

void lcd_box(uint _x,uint _y,uint x_range,uint y_range,uint line_color)
{
	LCD_block(_x,_y,(uint)(_x+x_range),_y,line_color);
	LCD_block(_x,_y,_x,(uint)(_y+y_range),line_color);
	LCD_block((uint)(_x+x_range),_y,(uint)(_x+x_range),(uint)(_y+y_range),line_color);
	LCD_block(_x,(uint)(_y+y_range),(uint)(_x+x_range),(uint)(_y+y_range),line_color);
}

//һťݣʼX/ʼY/X³/Yҳ/С7,8֡12/16/24/32У/ɫ/ɫ

void lcd_button(uint x,uint y,uint x_range,uint y_range,uchar zk_num,uchar *text,uint fount_color,uint line_color)
{
	uchar i=0;
	while(text[i]>0){i++;}
	LCD_block(x,y,(uint)(x+x_range),y,line_color);
	LCD_block(x,y,x,(uint)(y+y_range),line_color);
	LCD_block((uint)(x+x_range),y,(uint)(x+x_range),(uint)(y+y_range),line_color);
	LCD_block(x,(uint)(y+y_range),(uint)(x+x_range),(uint)(y+y_range),line_color);
	LCD_GB2312_String((uint)(((x*2+x_range)/2)-(i*zk_num/4)),(uint)(y+((y_range)/2)-((zk_num)/2)),zk_num,text,fount_color,fount_color);
}

