#include "oled_spi.h"
#include "oled_group.h"
#include "spi.h"

sbit DC_OLED=P4^1;
sbit CS_OLED=P3^7;
void oled_cmd(uchar cmd)
{
	DC_OLED=0;
	CS_OLED=0;
	spi_tx(cmd);
	CS_OLED=1;
}

void oled_dat(uchar dat)
{
	DC_OLED=1;
	CS_OLED=0;
	spi_tx(dat);
	CS_OLED=1;
}

void oled_line(uchar line,uchar dat)
{
	uchar i;
	oled_cmd(0x20);
	oled_cmd(0x00); 
	
	oled_cmd(0x21);
	oled_cmd(0x00);
	oled_cmd(0xff);
	oled_cmd(0x22);
	oled_cmd(line);
	oled_cmd(line);
	for(i=0;i<128;i++)
	{
		oled_dat(dat);
	}
}

void oled_full(uchar dat)
{
	uchar i;
	//oled_cmd(0xae);
	for(i=0;i<8;i++)
	{
		oled_line(i,dat);
	}
	//oled_cmd(0xaf);
}

void oled_half(uchar x,uchar y,uchar z)
{
	uchar i;
	oled_cmd(0x20);//Ѱַģʽ
	oled_cmd(0x00);//ˮƽѰַ
	oled_cmd(0x22);//ҳַ
	oled_cmd((uchar)(y*2));
	oled_cmd((uchar)(0x01+y*2));
	oled_cmd(0x21);
	oled_cmd((uchar)(0x08*x));
	oled_cmd((uchar)((0x08*x)+0x07));
	
	for(i=0;i<16;i++)
	{
		oled_dat(oled_num[z][i]);
	}
}

void oled_big_half(uchar x,uchar y,uchar z)
{
	uchar i;
	oled_cmd(0x20);//Ѱַģʽ
	oled_cmd(0x00);//ˮƽѰַ
	oled_cmd(0x22);//ҳַ
	oled_cmd((uchar)(y*2));
	oled_cmd((uchar)(0x03+y*2));
	oled_cmd(0x21);
	oled_cmd((uchar)(0x08*x));
	oled_cmd((uchar)((0x08*x)+0x0f));
	
	for(i=0;i<64;i++)
	{
		oled_dat(oled_big_num[z][i]);
	}
}

void oled_init()
{
	delay(500);
	oled_cmd(0xae);//رʾ
	oled_cmd(0x00);//ʼеλ0x0x
	oled_cmd(0x10);//ʼиλ0x1x
	oled_cmd(0x40);//setstart lineaddress Set MappingRAMDisplay Start Line(0x00~0x3F)
	oled_cmd(0x81);//Աȶ
	oled_cmd(0xff);//ԱȶΪ255
	oled_cmd(0xa1);//A0ҾA1
	oled_cmd(0xc8);//C0¾C8
	oled_cmd(0xa6);//Ĭʾ
	oled_cmd(0xa8);//ö·ñset multiplex ratio1 to 64
	oled_cmd(0x3f);//Ϊ64ֵ63
	oled_cmd(0xd3);//ʾƫλӳRAMset display offset Shift Mapping RAM Counter(00~3F)
	oled_cmd(0x00);//Ϊ00
	oled_cmd(0xd5);//ʾʱӷƵ/Ƶset display clock divideratio/oscillator frequency
	oled_cmd(0x80);//ʱӷָʣ100֡ÿ
	oled_cmd(0xd9);//Ԥset pre-charge period
	oled_cmd(0xf1);//Ԥ15ʱӣŵ1ʱ
	oled_cmd(0xda);//COMӲ
	oled_cmd(0x12);//
	oled_cmd(0xdb);//
	oled_cmd(0x40);//
	oled_cmd(0x20);//õַģʽ00ˮƽѰַ01ֱѰַ02ҳѰַ
	
	oled_cmd(0x02);//ҳѰַ
	oled_cmd(0x8d);//
	oled_cmd(0x14);//
	oled_cmd(0xa4);//
	oled_cmd(0xa6);//
	oled_cmd(0xaf);//ʾ
	oled_full(0x00);
}

void oled_test_3()//logo
{
	uchar i,j;
	oled_cmd(0xae);//ʾ
	oled_cmd(0x20);//ַģʽ
	oled_cmd(0x00);//ˮƽ
	
	oled_cmd(0x21);//еַΧ
	oled_cmd(0x00);
	oled_cmd(0xff);
	oled_cmd(0x22);//ҳַΧ
	oled_cmd(0x00);
	oled_cmd(0x07);
	
	for(i=0;i<64;i++)
	{
		for(j=0;j<16;j++)
		{
			oled_dat(oled_bmp[i][j]);
		}
	}
	oled_cmd(0xaf);
}

sbit CS_GT20=P3^6;

uchar G_RAM[32];
/*
void block_rx(uint addr)
{
	uchar i,MSB,LSB;
	//addr=(addr-0xA1A0)*32;
	MSB=addr/256%256;
	LSB=addr%256;
	
	if((MSB >= 0xA1) && (MSB <= 0xA5))//ַ
	{
		if     ((MSB == 0xA1) && (LSB >= 0xA1) && (LSB <= 0xBF))
		{
			addr=32*(LSB-0xA1)+0x8D80;
		}
		else if((MSB == 0xA3) && (LSB >= 0xA1) && (LSB <= 0xFE))
		{
			addr=32*(31+LSB-0xA1)+0x8D80;
		}
		else if((MSB == 0xA4) && (LSB >= 0xA1) && (LSB <= 0xF3))
		{
			addr=32*(125+LSB-0xA1)+0x8D80;
		}
		else if((MSB == 0xA5) && (LSB >= 0xA1) && (LSB <= 0xF6))
		{
			addr=32*(208+LSB-0xA1)+0x8D80;
		}
		else
		{
			addr=0x8D80;
		}
	}
	else if(((MSB >=0xB0) && (MSB <= 0xD7)) && ((LSB >= 0xA1) && (LSB <= 0xFE)))
	{
		addr=32*((MSB-0xB0)*94+(LSB-0xA1)+1)+0x16D0C;
	}
	else if(((MSB >=0xD8) && (MSB <= 0xF7)) && ((LSB >= 0xA1) && (LSB <= 0xFE)))
	{
		addr=2*((MSB-0xD8)*94+(LSB-0xA1))+0x1558C;
	}
	
	addr = ((MSB - 0xB0) * 94 + (LSB - 0xA1)+ 846)*32;
	
	
	
	
	
	//////////////////////////
	CS_GT20=0;
	spi_tx(0x03);
	spi_tx((uchar)(addr/65536%256));
	spi_tx((uchar)(addr/256%256));
	spi_tx((uchar)(addr%256));
	for(i=0;i<32;i++)
	{
		spi_tx(0xff);
		G_RAM[i]=SPDAT;
	}
	CS_GT20=1;
}
*/ 


void GT20L16P1Y_RX(uchar H,uchar M,uchar L,uchar j)
{
	uchar i;
	CS_GT20=0;
	spi_tx(0x03);
	spi_tx(H);
	spi_tx(M);
	spi_tx(L);
	for(i=0;i<j;i++)
	{
		spi_tx(0xff);
		G_RAM[i]=SPDAT;
	}
	CS_GT20=1;
}

void oled_text(uchar x,uchar y,uchar j)
{
	uchar i;
	oled_cmd(0x20);
	oled_cmd(0x00); 
	
	oled_cmd(0x21);
	oled_cmd(x);
	oled_cmd((uchar)(x+(j/2)-1));
	oled_cmd(0x22);
	oled_cmd(y);
	oled_cmd((uchar)(y+1));
	for(i=0;i<j;i++)
	{
		oled_dat(G_RAM[i]);
	}
}

ulong fontaddr=0;
void OLED_GB2312_string(uchar x,uchar y,uchar *text)
{
	uchar i=0;
	uchar addrHigh,addrMid,addrLow;
	while(text[i]>0x00)
	{
		if((text[i]>=0xb0)&&(text[i]<=0xf7)&&(text[i+1]>=0xa1))
		{
			fontaddr=(text[i]-0xb0)*94;
			fontaddr+=(text[i+1]-0xa1)+846;
			fontaddr=fontaddr*32;
			
			addrHigh=(fontaddr&0xff0000)>>16;
			addrMid=(fontaddr&0xff00)>>8;
			addrLow=(fontaddr&0xff);
			
			GT20L16P1Y_RX(addrHigh,addrMid,addrLow,32);
			oled_text(x,y,32);
			x+=16;
			i+=2;
    }
		else if((text[i]>=0xa1)&&(text[i]<=0xa3)&&(text[i+1]>=0xa1))
		{
			
			fontaddr=(text[i]-0xa1)*94;
			fontaddr+=(text[i+1]-0xa1);
			fontaddr=fontaddr*32;
			
			addrHigh=(fontaddr&0xff0000)>>16;
			addrMid=(fontaddr&0xff00)>>8;
			addrLow=(fontaddr&0xff);
			
			GT20L16P1Y_RX(addrHigh,addrMid,addrLow,32);
			oled_text(x,y,32);
			x+=16;
			i+=2;
    }
		else if((text[i]>=0x20)&&(text[i]<=0x7e))
		{
			fontaddr=(text[i]-0x20);
			fontaddr=(unsigned long)(fontaddr*16);
			fontaddr=(unsigned long)(fontaddr+0x3cf80);
			
			addrHigh=(fontaddr&0xff0000)>>16;
			addrMid=(fontaddr&0xff00)>>8;
			addrLow=fontaddr&0xff;
			
			GT20L16P1Y_RX(addrHigh,addrMid,addrLow,16);
			oled_text(x,y,16);
			x+=8;
			i+=1;
    }
		else 
			i++;
  }
}

